#
# spec file for package compat-libstdc++ (Version 5.0.7)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-32bit glibc-devel glibc-devel-32bit glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           compat-libstdc++
BuildRequires:  glibc-32bit glibc-devel-32bit
Version:        5.0.7
Release:        22.2
Autoreqprov:    on
License:        GPL
Group:          System/Libraries
Summary:        The Old stdc++ Library
ExclusiveArch: alpha %ix86 ia64 ppc ppc64 s390 s390x x86_64
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define gcc_version 3.3.5
Source:         gcc-%{gcc_version}.tar.bz2
Patch0:         gcc-3.3.5-hammer.patch.bz2
Patch1:         gcc-noalias-warn.diff
Patch2:         configure.patch
Patch3:         head-tail.patch
Patch4:         bug-reporting.patch
Patch5:         libgc.patch
Patch6:         ia64intrin.patch
Patch7:         ffi.patch
Patch8:         fworking-directory.patch
Patch10:        altivec.diff
Patch11:        compact-dwarf2.patch
Patch16:        c99-double-inline.diff
Patch17:        c99numbers.diff
Patch21:        gcse-volatile.patch
Patch22:        swig-alias.patch
Patch32:        aliasing.diff
Patch33:        aliasing12.diff
Patch34:        aliasing3.diff
Patch37:        cse-mem-expr.patch
Patch42:        emit-note.patch
Patch43:        unwind-ia64.patch
Patch44:        hppa.patch
Patch45:        suse46595.diff
Patch46:        stl-multiple-defs.diff
# Ada patches
Patch53:        gcc32-ada-link.patch
Patch54:        gcc32-ada-addr2line.patch
# c++ patches
# PPC specific
Patch61:        gcc-3.3-ppc64.patch
# Do not merge this patch into the Alan M patch, it will just get lost later.
# If you think it is useless, try building "fam" and watch libtool break.
Patch63:        ppc-nostartfileprefix.patch
Patch64:        ppc-nof.patch
Patch65:        cpp-fix-gcc4.diff
Patch66:        libstdc++-config.diff

%description
The standard C++ library, needed for dynamically linked C++ programs.

This package includes an older version for compatibility reasons.



%debug_package
%package -n compat-libstdc++-64bit
Autoreqprov:    on
Group:          System/Libraries
Summary:        The Old stdc++ Library

%description -n compat-libstdc++-64bit
This is a re-packaged binary rpm. For the package source, please look
for the source of the package without the "64bit" ending

The standard C++ library, needed for dynamically linked C++ programs.

This package includes an older version for compatibility reasons.



%define biarch_targets x86_64 s390x sparc64 ppc ppc64
%define TARGET_ARCH %(arch)
%if %(for arch in %{biarch_targets} ; do test %{TARGET_ARCH} = "$arch" && { echo 1 ; exit ; } ; done ; echo 0)
%define biarch 1
%else
%define biarch 0
%endif
%define BUILD_TARGET %(echo %{TARGET_ARCH}|sed -e "s/parisc/hppa/;s/i.86/i586/;s/ppc/powerpc/")
%ifarch sparc sparc64
%if %{biarch}
%define GCCDIST sparc64-suse-linux
%else
%define GCCDIST %{_target_cpu}-suse-linux
%endif
%else
%define GCCDIST %(echo %{_target_cpu}|sed -e "s/i.86/i586/" -e "s/ppc/powerpc/")-suse-linux
%endif
%define gcclibdir %{_libdir}/gcc-lib/
%define libsubdir %{_libdir}/gcc-lib/%{GCCDIST}/%{gcc_version}
%ifarch ppc ppc64
%define nofpath %{_prefix}/lib/nof
%endif
%prep
%setup -q -n gcc-%{gcc_version}
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8 -p1
%patch10
%patch11
%patch16
%patch17
%patch21
%patch22
%patch32
%patch33
%patch34
%patch37
%patch42
%patch43
%patch44
%patch45
%patch46
%patch53
%patch54
#%ifarch ppc ppc64
%patch61 -p1
#%patch63 -p1
#%endif
%patch64 -p1
%patch65
%patch66

%build
# Update version number
# not changed in ada (gcc/ada/gnatvsn.ads) since otherwise the line
# will be too long
perl -pi -e 's/\((prerelease|experimental|release)\)/(\1) (SUSE Linux)/' \
    gcc/version.c \
    libf2c/libF77/Version.c libf2c/libI77/Version.c libf2c/libU77/Version.c
# Remove -hammer
perl -pi -e 's/-hammer//' gcc/version.c
perl -pi -e 's/3\.3\.6/3.3.5/' gcc/version.c
# Handle gcc/version.c once again since a release might not have the
# release word in it:
perl -pi -e 's/(version_string.*\"[0-9.]+)\"/\1 \(SUSE Linux\)\"/' \
    gcc/version.c
# Avoid rebuilding of generated files
(cd gcc/ada; touch treeprs.ads einfo.h sinfo.h nmake.adb nmake.ads)
contrib/gcc_update --touch
rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`
%ifarch sparc sparc64
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m64//g' -e 's/-m32//g' -e 's/-mcpu=ultrasparc/-mtune=ultrasparc/g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
%endif
CFLAGS_FOR_TARGET=`echo $RPM_OPT_FLAGS|sed -e 's/mtune/mcpu/g' -e 's/-D_FORTIFY[^ ]*//g'`
languages=c,c++
%ifarch mips
export STAGE1_CFLAGS="$RPM_OPT_FLAGS"
%endif
ENABLE_CHECKING=--disable-checking
export _POSIX2_VERSION=199209
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" \
../configure --enable-threads=posix \
	--prefix=%{_prefix} --with-local-prefix=/usr/local \
	--infodir=%{_infodir} --mandir=%{_mandir} \
	--enable-languages=$languages $ENABLE_CHECKING \
	--libdir=%{_prefix}/%_lib \
        --disable-libgcj \
	--with-slibdir=/%{_lib} --with-system-zlib \
	--enable-shared --enable-__cxa_atexit \
%ifarch sparc
%if %{biarch}
	--with-cpu=v8 %{GCCDIST}
%else
	--host=%{GCCDIST} --build=%{GCCDIST} --target=%{GCCDIST} --with-cpu=v7
%endif
%else
%ifarch ppc
	--host=%{GCCDIST} --build=%{GCCDIST} --target=%{GCCDIST} \
	--enable-targets=powerpc64-suse-linux --enable-biarch
%else
%ifarch ppc64
	--enable-biarch \
%endif
	%{GCCDIST}
%endif
%endif
make %{?jobs:-j%jobs} CFLAGS_FOR_TARGET="$CFLAGS_FOR_TARGET" CXXFLAGS_FOR_TARGET="$CFLAGS_FOR_TARGET"

%install
cd obj-%{GCCDIST}
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install-target-libstdc++-v3
pushd $RPM_BUILD_ROOT/%{_prefix}
rm -rf include share
rm -rf lib*/*.a lib*/*.la lib*/lib*.so lib*/libsupc++*
%ifnarch x86_64 s390x ppc ppc64
other_lib=lib
test "%{_lib}" = "lib" && other_lib=lib64
test -d $other_lib && rm -rf $other_lib
%endif
popd

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%{_libdir}/libstdc++.so.*
%ifarch x86_64 s390x ppc64
%{_prefix}/lib/libstdc++.so.*
%endif
%ifarch ppc

%files -n compat-libstdc++-64bit
%defattr(-,root,root)
%{_prefix}/lib64/libstdc++.so.*
%endif

%changelog -n compat-libstdc++
* Mon Mar 06 2006 - schwab@suse.de
- Update build check.
* Fri Feb 24 2006 - matz@suse.de
- Recognize shared libgcc_s support also for ppc. [#153290]
* Tue Feb 14 2006 - matz@suse.de
- Build this the same way as gcc, i.e. all libs in one rpm, except
  on ppc. [#149110]
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Aug 19 2005 - matz@suse.de
- Build from sources [blocker #100149].
- Add cpp-fix-gcc4.diff.
* Mon May 09 2005 - schwab@suse.de
- Build on more architectures.
* Thu May 05 2005 - kukuk@suse.de
- Fix biarch on x86-64
* Fri Apr 08 2005 - ro@suse.de
- update to 3.3.5, add more architectures
* Fri Sep 10 2004 - ro@suse.de
- fix build on i686
* Thu Sep 09 2004 - ro@suse.de
- created package
